' (C) Copyright wellCAM CCS Lublin, 1998
'
' MAKRO TabelkaRysunkowa.MCR
' Dodanie tabelki rysunkowej i obramowa
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 14.07.98  wellCAM             Pierwsza wersja
' 28.07.98  wellCAM             HOMEDIRECTORY zamieniono na GDZIE_PROGRAM
'

' Start makra
Sub Main
	Begin Dialog UserDialog 380,161,"Tabelka rysunkowa" ' %GRID:10,7,1,1
		CheckBox 40,35,320,14,"Wstaw tabelk rysunkow",.chkTabelka
		CheckBox 40,56,320,14,"Rysuj obramowanie pola rysunkowego",.chkRamka
		CheckBox 40,77,320,14,"Rysuj obramowanie formatu arkusza",.chkFormat
		OKButton 60,119,90,21
		CancelButton 220,119,90,21
	End Dialog
	Dim dlg As UserDialog
	result = Dialog(dlg)
	If (-1 = result) Then
		If dlg.chkTabelka Then
			Call WstawTabelke
		End If
		If dlg.chkRamka Then
			Call RysujRamke
		End If
		If dlg.chkFormat Then
			Call ZaznaczFormat
		End If
	End If
End Sub
'
'Wstawienie tabelki (tabliczki) rysunkowej
Sub WstawTabelke
	Dim Doc As Object
	Dim dwg As Object

	Set doc = Application.ActiveDocument
	Set dwg = doc.Drawing

	Dim dx, dy as integer
	dim bff as string
	dx = dwg.Width  'szeroko formatki rysunku
	dy = dwg.Height 'wysoko formatki rysunku
	bff = "(" & dx-5 & ",5)

	Dim fileName As String
	fileName = "%GDZIE_PROGRAM%\Formatki\Tabelki\Tabelka_00.ict"
	dwg.ExecuteString("OBW(n=" & fileName & ", skala=1, p=" & bff & ")")
End Sub
'
'Narysowanie obramowania dookoa pola rysunkowego
Sub RysujRamke
	Dim Doc As Object
	Dim dwg As Object

	Set doc = Application.ActiveDocument
	Set dwg = doc.Drawing

	Dim dx, dy as integer
	dx = dwg.Width  'szeroko formatki rysunku
	dy = dwg.Height 'wysoko formatki rysunku

	Dim idx As Long
	idx = dwg.AddObject() 'Stwrz nowy obiekt, pobierz jego indeks
	If (idx > 0) Then
		dwg.OpenObject(idx) 'Otwrz obiekt w celu dodania grafiki
		dwg.AddLine  5,  5, dx-5,  5, 1, -1
		dwg.AddLine dx-5,  5,  dx-5, dy-5, 1, -1
		dwg.AddLine  dx-5,  dy-5, 5,  dy-5, 1, -1
		dwg.AddLine  5,  dy-5, 5,  5, 1, -1
		dwg.AddAttribute("Obiekt", "Obramowanie pola rysunku") 'Dodatkowy atrybut
		dwg.CloseObject() 'Zamknij obiekt
	End If
End Sub
'
'Narysowanie obramowania dookoa pola arkusza
Sub ZaznaczFormat
	Dim Doc As Object
	Dim dwg As Object

	Set doc = Application.ActiveDocument
	Set dwg = doc.Drawing

	Dim dx, dy as integer
	dx = dwg.Width  'szeroko formatki rysunku
	dy = dwg.Height 'wysoko formatki rysunku

	Dim idx As Long
	idx = dwg.AddObject() 'Stwrz nowy obiekt, pobierz jego indeks
	If (idx > 0) Then
		dwg.OpenObject(idx) 'Otwrz obiekt w celu dodania grafiki
		dwg.AddLine  0,  0, dx,  0, 2, -1
		dwg.AddLine dx,  0,  dx, dy, 2, -1
		dwg.AddLine  dx,  dy, 0,  dy, 2, -1
		dwg.AddLine  0,  dy, 0,  0, 2, -1
		dwg.AddAttribute("Obiekt", "Obramowanie formatu rysunku") 'Dodatkowy atrybut
		dwg.CloseObject() 'Zamknij obiekt
	End If
End Sub
'
