' Trzpien.mcr
'
' Przykad makra tworzcego i rozmieszczajcego obiekty dynamicznie
'
' (c) wellCAM CCS, LUBLIN
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 17.03.98  wellCAM             Pierwsza wersja
'


Sub Main

	Dim Doc As Object
	Set doc = Application.ActiveDocument
	Dim dwg As Object
	Set dwg = doc.Drawing 'obiekt rysunku

	Dim idx As Long
	idx = dwg.AddObject() 'Stwrz nowy obiekt, pobierz jego indeks
	If (idx > 0) Then
		dwg.OpenObject(idx)                   'Otwrz obiekt w celu dodania grafiki
		DrawSymbol dwg, 0, 0, 30, 70        'Rysuj gwint
		dwg.SetPointORD(0, 0)               'Punkt orientacyjny obiektu
		dwg.AddAttribute("Obiekt", "Trzpie") 'Dodatkowe atrybuty
		dwg.AddAttribute("Rozmiar", "30 x 60")
		dwg.CloseObject()                     'Zamknij obiekt
		dwg.ExecuteString("SUW(mode=OSTOBI,p=[0, 0])") 'ustaw obiekt dynamicznie
	End If

End Sub

'Podprogram - rysowanie trzpienia
Sub DrawSymbol(dwg As Object, x As Double, y As Double, vDia As Double, vLen As Double)
  'zarys
	dwg.AddLine x, y-vDia/2, x+vLen, y-vDia/2, 1, -1
	dwg.AddLine x+vLen, y-vDia/2, x+vLen, y+vDia/2, 1, -1
	dwg.AddLine x+vLen, y+vDia/2, x, y+vDia/2, 1, -1
	dwg.AddLine x, y+vDia/2, x, y-vDia/2, 1, -1

  'gwint
	dwg.AddLine x, y-vDia/2 + 2, x+vLen, y-vDia/2 + 2, 2, -1
	dwg.AddLine x, y+vDia/2 - 2, x+vLen, y+vDia/2 - 2, 2, -1

  'o
	dwg.AddLine x-5, y, x+vLen+5, y, 4, -1

  'tekst 5mm
	Dim hgt As Double, wdt As Double, agl As Double
	Dim jst As Integer, slt As Integer
	dwg.GetTextParameters hgt, wdt, agl, jst, slt
	dwg.SetTextParameters 5, 3.5, 0, 1, slt
	dwg.AddText x, y+vDia/2+2,"Przykad", 2, -1

End Sub
